/*----------------------------------------------------------\
|										|
|		    [AMXBans] SteamID Validator			|
|				 v1.2 Beta					|
|										|
|			    Made By: PrefeX				|
|										|
|-----------------------------------------------------------|
|										|										|
| Credits:									|
|										|
| pRED - For helping me solve some issues				|
| Nican - For helping me solve a case issue I overlooked	|
| Olly - For some minor issues					|
| Everyone that made the guides in the WIKI section		|										|
|										|
|-----------------------------------------------------------|
|										|
| Changelog:								|
|										|
| v1.2 Beta									|
|	- Fixed several typos						|
|	- Added a version cvar						|
|	- Changed the system so "amxbans_localbanlength -1"	|
|	  result in players not being banned locally		|
|										|
| v1.1 Beta									|
| 	- Added commands to change banreason			|
| 	- Added commands to change bantime (local)		|
| 	- Added commands to disable the plugin			|
| 	- Added local ban (banid) to avoid flooding of SQL	|
| 										|
| v1.0 Beta - First release						|
|	- First release							|
|										|
\----------------------------------------------------------*/


#include <sourcemod>
#define PLUGIN_VERSION "1.2 Beta"


public Plugin:myinfo =
{
	name		= "AMXBans SteamID Validator",
	author	= "PrefeX",
	description	= "Validates users from the AMXBans database",
	version	= PLUGIN_VERSION,
	url		= "http://gamer.itavisen.no"
}


new Handle:hDatabase		= INVALID_HANDLE;
new Handle:g_Enable		= INVALID_HANDLE;
new Handle:g_LocalBanLength	= INVALID_HANDLE;
new Handle:g_BanMessage		= INVALID_HANDLE;


public OnPluginStart()
{

	// Settings
	g_Enable		= CreateConVar("amxbans_enable", "1", "Enable or disable the plugin.")
	g_LocalBanLength	= CreateConVar("amxbans_localbanlength", "5", "How long do you want to ban the player locally after being kicked? If set to -1 locally bans are disabled, and the player will just be kicked.")
	g_BanMessage	= CreateConVar("amxbans_banmessage", "[AMXBans] You are banned from this server!", "The message that's showed to the user when kicked or banned.")
//	g_ExtraDebug	= CreateConVar("amxbans_debug", "0", "Enable or disable extra debug messages.")
	CreateConVar("amxbans_sm_version", PLUGIN_VERSION, "AMXBans SteamID Validator Version", FCVAR_PLUGIN|FCVAR_SPONLY|FCVAR_REPLICATED|FCVAR_NOTIFY)



	// Misc (Connection to DB/Give deactivation warning)
	if (GetConVarInt(g_Enable) == 1)
	{
		SQL_TConnect(GotDatabase, "amxbans")
		PrintToServer("[AMXBans] Connecting to DB")
	}
	else if (GetConVarInt(g_Enable) == 0)
	{
		PrintToServer("[AMXBans] WARNING - The plugin is disabled!")
		PrintToServer("[AMXBans] This will disable the check for banned players. To reactivate, set 'amxbans_enable' to 1")
	}

}


public GotDatabase(Handle:owner, Handle:hndl, const String:error[], any:data)
{

	if (hndl == INVALID_HANDLE)
	{
		LogError("[AMXBans] Database failure: %s", error);
		PrintToServer("[AMXBans] Failed to connect to DB")
	}
	else
	{
		PrintToServer("[AMXBans] Connected to DB")
		hDatabase = hndl;
	}

}


public OnClientAuthorized(userid, const String:auth[])
{

	if (GetConVarInt(g_Enable) == 1)
	{
		decl String:query[255];
		Format(query, sizeof(query), "SELECT player_id FROM amx_bans WHERE player_id = '%s'", auth);
		SQL_TQuery(hDatabase, T_CheckSteamID, query, userid)
	}
	else if (GetConVarInt(g_Enable) == 0)
	{
		PrintToServer("[AMXBans] The plugin is disabled. Player not checked!")
	}

}


public T_CheckSteamID(Handle:owner, Handle:hndl, const String:error[], any:player)
{

	// Make sure the client didn't disconnect while the thread was running
	if(!IsClientConnected(player) && player > 0)
	{
		return;
	}

	if (hndl == INVALID_HANDLE)
	{
		LogError("[AMXBans] Query failed! %s", error);
	}
	else if (SQL_GetRowCount(hndl))
	{
		new BanTime = GetConVarInt(g_LocalBanLength)
		new String:BanReason[64]
		GetConVarString(g_BanMessage,BanReason,64)

		if (GetConVarInt(g_LocalBanLength) == -1)
		{
			KickClient(player, BanReason)
		}
		else
		{
			BanClient(
				player, 
				BanTime, 
				BANFLAG_AUTO, 
				BanReason, 
				BanReason, 
				"local_ban",
				player);
		}
	}

}